subroutine sub_simul(euler_errors,g_k,grid_k,length_grid_k,transition,transitioncdf,k_ss)
		
	use mod_types
	use mod_common_var
	use msimsl

	implicit none

	integer, intent(in) :: length_grid_k

	real(dp), dimension(length_grid_k,n_tauchen), intent(inout) :: euler_errors, g_k
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition, transitioncdf
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), intent(in) :: k_ss

	integer :: iter, go_on, index_k, index_z, time, productivity
	integer, dimension(1) :: j
	
	real :: randomnumber
	real(dp), dimension(Tsimul) :: eerrorsim, ones
	real(dp), dimension(2) :: capital
	real(dp):: meaneerror,maxeulererror
	
	!Specifies the initial level of capital and the productivity shock.
	capital(1)=k_ss
	productivity=2

	euler_errors=log10(abs(euler_errors))

	do time=2,Tsimul+1
		randomnumber= rnunf()
		call sub_myinterp(grid_k,euler_errors(:,productivity),capital(1),length_grid_k,eerrorsim(time-1))
		call sub_myinterp(grid_k,g_k(:,productivity),capital(1),length_grid_k,capital(2))
		j = minloc(transitioncdf(productivity,:), mask=transitioncdf(productivity,:)>randomnumber)
		productivity=j(1)
		capital(1)=capital(2)
	enddo	
	
	ones=1
	meaneerror=dot_product(eerrorsim,ones)/Tsimul
	maxeulererror = maxval(euler_errors)
	
	print *, ' '
	print *, 'the mean euler equation errors on the simulated path is'
	print *, meaneerror
	print *, ' '
	print *, 'the maximun euler equation error is'
	print *, maxeulererror

end subroutine sub_simul