subroutine sub_value(value,g_k,g_c,grid_k,length_grid_k,y,transition)
		
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k

	real(dp), dimension(length_grid_k,n_tauchen), intent(inout) :: value,g_k,g_c
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), dimension(n_tauchen), intent(in) :: y
	
	integer :: iter, index_k, index_z

	real(dp), dimension(length_grid_k,n_tauchen) :: cih, D, Cstar, Vend, Vend1, Yend, value1, kend
	real(dp) :: diff

  iter = 0
  diff = 1000.d0

    ! Need to define "cash in hand" tomorrow.

	do index_k = 1,length_grid_k
		do index_z = 1,n_tauchen
			cih(index_k,index_z)=exp(y(index_z))*grid_k(index_k)**alpha+(1-delta)*grid_k(index_k)
		enddo
	enddo


	!Here we start the iterations.
	
	iter=0
	diff=1
	
	do while(diff>toler)
		iter=iter+1
		!Compute the derivatives of Vtilda at the grid points only.
		D(1,:)=(value(2,:)-value(1,:))/step
		D(length_grid_k,:)=(value(length_grid_k,:)-value(length_grid_k-1,:))/step
		do index_k = 2,length_grid_k-1
			D(index_k,:)=(value(index_k+1,:)-value(index_k-1,:))/(2.d0*step)
		enddo
			
		Cstar=D**(-1/tau)
		Vend=1/(1-tau)*Cstar**(1-tau)+value
		
		do index_z = 1,n_tauchen
			Yend(:,index_z)=Cstar(:,index_z)+grid_k
			call sub_myinterp1(Yend(:,index_z),Vend(:,index_z), cih(:,index_z), length_grid_k, Vend1(:,index_z))	
		enddo
						
		do index_k = 1,length_grid_k
			do index_z = 1,n_tauchen
				value1(index_k,index_z)=beta*dot_product(transition(index_z,:),Vend1(index_k,:))	
			enddo
		enddo

		diff = maxval(abs(value1-value))
		value=value1
		if (mod(iter,50)==0) print *, 'Iteration: ', iter, 'Tolerance ', diff
	enddo

	! At this point the program recovers the endogenous grid for capital.	
	do index_k = 1,length_grid_k
		do index_z = 1,n_tauchen
			call sub_kendogenousnewton(kend(index_k,index_z),Yend(index_k,index_z),y(index_z),grid_k(index_k))	
		enddo
	enddo

	! Here we interpolate capital on the grid so that we can compare the results to the standard algorithm.
	do index_z = 1,n_tauchen
		call sub_myinterp1(kend(:,index_z),Vend(:,index_z), grid_k, length_grid_k, value(:,index_z))
		call sub_myinterp1(kend(:,index_z),grid_k, grid_k, length_grid_k, g_k(:,index_z))
		call sub_myinterp1(kend(:,index_z),Cstar(:,index_z), grid_k, length_grid_k, g_c(:,index_z))
	enddo


end subroutine sub_value